<?php
/*
    Newsletter - GuppY PHP Script - version 4.6
    CeCILL Copyright (C) 2004-2007 by Laurent Duveau
    Initiated by Laurent Duveau and Nicolas Alves
      Web site = http://www.freeguppy.org/
      e-mail   = info@freeguppy.org

    Version History :
      v3.0 (25 February 2004)     : initial release by Nicolas Alves and Laurent Duveau
      v3.0p1 (26 Feb 2004)        : ergonomic fixes in the e-mails sent when a user subscribes to the newsletter
      v4.0 (06 December 2004)     : added page title (by Jean-Mi)
      v4.6.0 (04 June 2007)       : updated email checking (by Icare)
                                    corrected function IsValidMail (by djchouix and hpsam)
                                    corrected bad remove (by hpsam)
*/

header("Pragma: no-cache");
define("CHEMIN", "");
// Added cryptographp ==>
$cryptinstall = CHEMIN.'plugins/cryptographp/cryptographp.fct.php';
$crypterror = false;
include_once $cryptinstall;
// <== cryptographp
include("inc/includes.inc");
// Added / Modified cryptographp ==>
include_once(CHEMIN.'plugins/cryptographp/inc/function.inc');
if ($serviz[36] != "on" && $cp_cfg[6] != "on") {
  exit($web143);
}
// <== cryptographp
if (import('action', 'GET') != NULL && $_GET['action'] == 'sub')  die('STOP ! Variable $action: illegal origine !');
if (!isset($nlpseudo)) {
  header("location:index.php?lng=".$lng);
}
function IsValidEmail($email) {
  $result[0] = true;
  $result[1] = '';
  if (!preg_match("`^[a-zA-Z][a-zA-Z0-9_-]*(?:\.[a-zA-Z0-9_-]+)*@[a-zA-Z][a-zA-Z0-9-]*(?:\.[a-zA-Z0-9-]+)*\.[a-z]{2,6}$`", $email)) {
    $result[0] = false;
    $result[1] = 'Email est mal form - Email is not properly formatted';
  }
  else {
    list($username, $domain ) = split("@", $email);
    $verify = "on"; $debug = "on";
    if (function_exists('checkdnsrr')) {
      # Construct array of available mailservers
      if (getmxrr($domain, $mxhosts, $mxweight)) {
        for($i=0;$i<count($mxhosts);$i++){
          $mxs[$mxhosts[$i]] = $mxweight[$i];
        }
        asort($mxs);
        $mailers = array_keys($mxs);
      }
      elseif(checkdnsrr($domain, 'A')) {
         $mailers[0] = gethostbyname($domain);
      }
      else {
       $mailers=array();
      }
      $total = count($mailers);
      # Query each mailserver
      if ($total > 0 && $verify) {
        # Check if mailers accept mail
        for($n=0; $n < $total; $n++) {
          # Check if socket can be opened
          if ($debug) { echo "Checking server $mailers[$n]...\n";}
          $connect_timeout = 2;
          $errno = 0;
          $errstr = 0;
          $probe_address = 'postmaster@'.$domain;
          # Try to open up socket
          if ($Connect = @fsockopen($mailers[$n], 25, $errno , $errstr, $connect_timeout)) {
            $Out = fgets($Connect, 1024);
            echo $Out.'<br />';
            if (ereg("^220", $Out)) {
              fputs ($Connect, 'HELO '.$_SERVER['HTTP_HOST']."\r\n");
              $Out = fgets ( $Connect, 1024 );
              fputs ($Connect, "MAIL FROM: <$email>\r\n");
              $From = fgets ( $Connect, 1024 );
              fputs ($Connect, "RCPT TO: <$email>\r\n");
              $To = fgets ($Connect, 1024);
              echo $Out.'<br />';
              fputs ($Connect, "QUIT\r\n");
              fclose($Connect);
              if (!ereg ("^250", $From) || !ereg ( "^250", $To )) {
                $result[0]=false;
                $result[1]="Adresse rejet par le serveur - Server rejected address";
                return $result;
                exit();
              }
            }
          }
          else {
            $result[0]= false;
            $result[1]="Pas de connexion au serveur - No connection to the server.";
          }
        }
      }
    }
  }
  return $result;
}
$valemail = IsValidEmail($nlmail);
if (!$valemail[0]) die('STOP ! '.$valemail[1]);
if (eregi('^(http|ftp|Votre|Your)', $nlpseudo)) die('STOP ! illegal pseudo');

$nlpseudo = KeepGoodChars(CutLongWord(strip_tags(stripslashes($nlpseudo)),20));
$nlmail = strip_tags(stripslashes($nlmail));

$topmess = $web222;
include("inc/hpage.inc");
htable($web222, "100%");
// cryptographp ==>
if (chk_crypt($_POST['cryptcodenl']) || $action == "unsub") {
// <== cryptographp

if ($action == "sub") {
  $error = "";
  if(($nlpseudo == "") or ($nlpseudo == KeepGoodChars($web259))) {
    $error = '<p align="justify"> - '.$web252.'</p>';
  }
  if ((!ereg("^(.+)@(.+)\\.(.+)$",$nlmail)) || ($nlmail == "") || ($nlmail == $web260)) {
    $error .= "<p align=\"justify\"> - ".$web251."</p>";
  }
  if ($error == "") {
    $controle = CheckDB1Field(DBNEWSLETTER,$nlpseudo,0);
    if ($controle) {
    $error = $web405;
    }
    else{
      $controle = CheckDB1Field(DBNEWSLETTER,$nlmail,1);
      if ($controle) {
        $error = $web250;
      }
    }
    if (!$controle) {
      echo '<p>'.$web249.'<b> '.$nlpseudo.'</b><br /><br />'.$web50.'<b> '.$nlmail.'</b> '.$web248.'</p><br />';
      $nllist = array();
      $nllist[0] = $nlpseudo;
      $nllist[1] = $nlmail;
      $nllist[2] = $lng;
      AppendDBFields(DBNEWSLETTER,$nllist);
      if ($supervision[7] == "on") {
        $to = $nlmail;
        $sujet = $site[0]." - ".$web246;
        $body  = $web245." ".$nlpseudo.$web244." ".$site[0]."<hr />";
        $body .= $web235."<br />".$user[0]."<br />".$site[3]."<hr />";
        $body .= $web243."<br />";
        $body .= '<a href="'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'">'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'</a>';
        eMailHtmlTo($sujet,$body,$to);
        $body  = $nlpseudo.' ('.$nlmail.') '.$web242.' '.$site[0]."<hr />";
        $body .= $web241.":<br />";
        $body .= '<a href="'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'">'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'</a>';
        eMailHtmlTo($sujet,$body,"");
      }
    }
    else {
      echo '<br /><p>'.$web250.'</p><br />';
    }
  }
  else {
    echo '<p align="justify"><b>'.$web256.'</b></p><br />'.$error;
  }
 }
 elseif ($action == "unsub") {
  $error = "";
  if (($nlpseudo == "") || ($nlpseudo == KeepGoodChars($web259))) {
    $error = '<p align="justify"> - '.$web252.'</p>';
  }
  if ((!ereg("^(.+)@(.+)\\.(.+)$",$nlmail)) || ($nlmail == "") || ($nlmail == $web260)) {
    $error .= '<p align="justify"> - '.$web251.'</p>';
  }
  if ($error == "") {
    $controle = CheckDB2Fields(DBNEWSLETTER,$nlpseudo,0,$nlmail,1);
    if ($controle) {
      $nlpseudo = stripslashes($nlpseudo);
      $newdb = array();
      $dbwork = ReadDBFields(DBNEWSLETTER);
      for ($i = 0; $i < count($dbwork); $i++) {
        if ($dbwork[$i][1] == $nlmail) {
          if ($dbwork[$i][0] != $nlpseudo)
              $newdb[] = $dbwork[$i];
        }
        else {
            $newdb[] = $dbwork[$i];
        }
      }
      WriteDBFields(DBNEWSLETTER,$newdb);
      echo '<p>'.$web253.'<b> '.$nlpseudo.'</b><br /><br />'.$web255.'<b> '.$nlmail.'</b> '.$web254.'</p><br />';
      if ($supervision[7] == "on") {
        $to = $nlmail;
        $sujet  = $site[0]." - ".$web241;
        $body  = $web240." ".$nlpseudo.$web239." ".$site[0]."<hr />";
        $body .= $web235."<br />".$user[0]."<br />".$site[3]."<hr />";
        $body .= $web234."<br />";
        $body .= '<a href="'.$site[3].'newsletter.php?lng='.$lng.'&;action=sub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'">'.$site[3].'newsletter.php?lng='.$lng.'&;action=sub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'</a>';
        eMailHtmlTo($sujet,$body,$to);
        $body  = $nlpseudo." (".$nlmail.") ".$web238." ".$site[0]."\n";
        eMailHtmlTo($sujet,$body,"");
      }
    }
    else {
      echo '<br /><p>'.$web255.'<b>'.$nlmail.'</b>'.$web233.'</p><br />';
    }
  }
  else {
    echo '<p align="justify"><b>'.$web256.'</b></p><br />'.$error;
  }
}
// cryptographp ==>
}
else {
	echo '<div align="center" style="color:red; background-color:yellow; border:1px solid red; font-weight:bold;">'.$cp_web1.'</div>';
}
// <== cryptographp
btable();
include("inc/bpage.inc");
?>